#pragma once

#include <Orange/Core/Types.h>

namespace orange
{
    template <typename T>
    struct Span
    {
        Span(T* data, size_t size) : data(data), size(size) {}

        template <size_t Count>
        Span(T (&array)[Count]) : data(array), size(Count) {}

        explicit Span(T* data) : data(data), size(1) {}
        explicit Span(T& data) : data(&data), size(1) {}
        
              T& operator [] (size_t idx)       { return data[idx]; }
        const T& operator [] (size_t idx) const { return data[idx]; }

        bool IsEmpty() const { return size == 0; }

              T& front()       { return *data[idx]; }
        const T& front() const { return *data[idx]; }

              T& back()       { return *data[size - 1]; }
        const T& back() const { return *data[size - 1]; }

        T* data;
        size_t size;
    };
}
